module.exports = {
  root: true,
  extends: [
    "plugin:@typescript-eslint/recommended",
    "airbnb-base",
  ],
  plugins: [
    "@typescript-eslint",
  ],
  parserOptions: {
    parser: "@typescript-eslint/parser",
    ecmaVersion: 2020,
  },
  rules: {
    // 空函数
    "no-empty-function": "off",
    // 没用的构造函数
    "no-useless-constructor": "off",
    // 一个文件中可以有多个类
    "max-classes-per-file": "off",
    "no-debugger": process.env.NODE_ENV === "production" ? "warn" : "off",
    "no-console": process.env.NODE_ENV === "production" ? "warn" : "off",
    "no-bitwise": "off",
    "no-tabs": "off",
    "array-element-newline": ["error", "consistent"],
    indent: ["error", 2, { MemberExpression: 0, SwitchCase: 1, ignoredNodes: ["TemplateLiteral"] }],
    quotes: [1, "double"],
    // 后面的逗号
    "comma-dangle": ["off", "never"],
    "object-curly-spacing": ["error", "always"],
    "max-len": ["error", 180],
    "no-new": "off",
    "linebreak-style": "off",
    "import/extensions": "off",
    "eol-last": "off",
    "no-shadow": "off",
    "no-undef": "off",
    "no-unused-vars": "warn",
    "import/no-cycle": "off",
    "arrow-parens": "off",
    semi: [2, "always"],
    // 'eqeqeq': 'off',
    "no-param-reassign": "off",
    "import/prefer-default-export": "off",
    "no-use-before-define": "off",
    "no-continue": "off",
    "prefer-destructuring": "off",
    "no-plusplus": "off",
    "prefer-const": "off",
    "global-require": "off",
    "no-prototype-builtins": "off",
    "consistent-return": "off",
    "prefer-template": "off",
    "one-var-declaration-per-line": "off",
    "one-var": "off",
    "import/named": "off",
    "object-curly-newline": "off",
    "default-case": "off",
    "import/order": "off",
    "no-trailing-spaces": "off",
    "func-names": "off",
    radix: "off",
    "no-unused-expressions": "off",
    "no-underscore-dangle": "off",
    "no-nested-ternary": "off",
    "no-restricted-syntax": "off",
    "no-mixed-operators": "off",
    "no-await-in-loop": "off",
    "import/no-extraneous-dependencies": "off",
    "import/no-unresolved": "off",
    "no-case-declarations": "off",
    "template-curly-spacing": "off",
    "@typescript-eslint/no-var-requires": "off",
    "@typescript-eslint/no-empty-function": "off",
    "no-empty": "off",
    "@typescript-eslint/no-explicit-any": "off",
    "guard-for-in": "off",
    "@typescript-eslint/ban-types": "off",
    "class-methods-use-this": "off",
    "no-return-await": "off"
  },
};
