const fs = require("fs");

const stat = fs.stat;

/**
 * 打包的时候，将对应的.ts文件拷贝到dist目录下，这样其他项目引入该库的时候时，可以直接跳到.ts文件
 */
function copyFile(source, target) {
  fs.readdir(source, (err, paths) => {
    if (err) {
      throw err;
    }
    paths.forEach((path) => {
      const sourcePath = `${source}/${path}`;
      const targetPath = `${target}/${path}`;
      let readable;
      let writable;
      stat(sourcePath, (err, result) => {
        if (err) {
          throw err;
        }
        if (result.isFile() && path.indexOf(".test.ts") === -1) {
          readable = fs.createReadStream(sourcePath);
          writable = fs.createWriteStream(targetPath);
          readable.pipe(writable);
        } else if (result.isDirectory()) {
          copyFile(sourcePath, targetPath);
        }
      });
    });
  });
}

copyFile("./src", "./dist");
