"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Utils = void 0;
var Utils = (function () {
    function Utils() {
    }
    Utils.debounced = function (_func, _delay, _immediate) {
        var _this = this;
        if (_delay === void 0) { _delay = 500; }
        if (_immediate === void 0) { _immediate = false; }
        var timer;
        return function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            if (_immediate) {
                _func.apply(_this, args);
                _immediate = false;
                return;
            }
            clearTimeout(timer);
            timer = setTimeout(function () {
                _func.apply(_this, args);
            }, _delay);
        };
    };
    Utils.throttle = function (_func, _delay) {
        var _this = this;
        if (_delay === void 0) { _delay = 500; }
        var flag = true;
        var timer;
        return function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            if (flag) {
                _func.apply(_this, args);
                flag = false;
                clearTimeout(timer);
                timer = setTimeout(function () {
                    flag = true;
                }, _delay);
            }
        };
    };
    Utils.deepClone = function (_object, _obj) {
        if (_obj === void 0) { _obj = {}; }
        return function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            if (!(Object.prototype === Object.getPrototypeOf(_object))) {
                return new Error("传入参数***_object***类型错误");
            }
            for (var key in _object) {
                if (Object.prototype === Object.getPrototypeOf(_object[key])) {
                    _obj[key] = Utils.deepClone(_object[key]);
                }
                else {
                    _obj[key] = _object[key];
                }
            }
            return _obj;
        };
    };
    return Utils;
}());
exports.Utils = Utils;
//# sourceMappingURL=index.js.map