"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApiClient = void 0;
var axios_1 = require("axios");
var __1 = require("..");
var ApiClientError_1 = require("./ApiClientError");
var ApiClientErrorType_1 = require("./ApiClientErrorType");
var ApiClient = (function () {
    function ApiClient(baseUrl, timeoutSeconds, headers) {
        if (timeoutSeconds === void 0) { timeoutSeconds = 60000; }
        this.axiosInstance = axios_1.default.create({
            baseURL: baseUrl,
            timeout: timeoutSeconds * 1000,
            headers: __assign({ "Content-Type": "application/json" }, headers)
        });
        this.baseUrl = baseUrl;
    }
    ApiClient.prototype.sendAsync = function (request) {
        return __awaiter(this, void 0, void 0, function () {
            var clientMock, requestMessage, requestBody, axiosRequest, axiosResponse, _a, responseBody, responseMessage;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        clientMock = ApiClient.clientMocks[request.url];
                        console.log("====sendAsync===请求url=", ApiClient.clientMocks, "".concat(this.baseUrl).concat(request.url), request);
                        if (!(clientMock != null)) return [3, 2];
                        console.log("====sendAsync===是否有mock方法=", clientMock);
                        return [4, clientMock(request)];
                    case 1: return [2, _b.sent()];
                    case 2:
                        requestMessage = new __1.ApiRequestMessage();
                        requestMessage.params = request;
                        requestBody = JSON.stringify(requestMessage);
                        axiosRequest = {
                            url: request.url,
                            method: "POST",
                            data: requestBody,
                            transformRequest: function (request) { return request; },
                            transformResponse: function (response) { return response; }
                        };
                        _b.label = 3;
                    case 3:
                        _b.trys.push([3, 5, , 6]);
                        return [4, this.axiosInstance(axiosRequest)];
                    case 4:
                        axiosResponse = _b.sent();
                        return [3, 6];
                    case 5:
                        _a = _b.sent();
                        throw new ApiClientError_1.ApiClientError(ApiClientErrorType_1.ApiClientErrorType.BadNetwork);
                    case 6:
                        if (axiosResponse.status >= 300) {
                            throw new ApiClientError_1.ApiClientError(ApiClientErrorType_1.ApiClientErrorType.BadHttpStatus, axiosResponse.status);
                        }
                        responseBody = axiosResponse.data;
                        try {
                            responseMessage = JSON.parse(responseBody);
                            if (!responseMessage) {
                                throw new Error();
                            }
                        }
                        catch (_c) {
                            throw new ApiClientError_1.ApiClientError(ApiClientErrorType_1.ApiClientErrorType.BadResponseData, axiosResponse.status);
                        }
                        if (!responseMessage.result || responseMessage.error) {
                            throw new ApiClientError_1.ApiClientError(ApiClientErrorType_1.ApiClientErrorType.Application, axiosResponse.status, responseMessage.error);
                        }
                        return [2, responseMessage.result];
                }
            });
        });
    };
    ApiClient.clientMocks = {};
    return ApiClient;
}());
exports.ApiClient = ApiClient;
//# sourceMappingURL=ApiClient.js.map