import { ApiResponseError } from "..";
import { ApiClientErrorType } from "./ApiClientErrorType";

/**
 * 表示一个API客户端错误。
 */
export class ApiClientError extends Error {
  // #region Constructors

  constructor(type: ApiClientErrorType, status?: number, responseError?: ApiResponseError) {
    super();
    this.type = type;
    this.status = status;
    this.responseError = responseError;
  }

  // #endregion

  // #region 详情

  /**
   * 类型
   */
  type: ApiClientErrorType = ApiClientErrorType.Unknown;

  /**
   * 响应状态
   */
  status: number | undefined;

  /**
   * 响应错误
   */
  responseError: ApiResponseError | undefined;

  // #endregion
}
